
#include <stdio.h>
#include <stdlib.h>
#include "cube.h"
#include "dict.h"
#include "boggle.h"


Dict userTurn (char* cube, Dict dict, Dict computer ) {
	char input[80];
	int i=0;
	Dict user;
	user = createDict();
	input[0]=0;
	printf("Your Turn (enter words followed by a .)\n");
	while ( input[0] != '.' ) {
		fgets (input, 79, stdin);
		while (input[i]) {
			input[i] = tolower (input[i]);
			i++;
		}
		input[strlen (input) -1] = 0;
		if (strlen (input) < 4 ) 
			printf ("You word must be at least 4 characters\n");
		else if (!(isWord(dict, input) & 0x02) )
			printf ("Your word must be a legal dictionary word\n");
		else if (isWord(user, input) & 0x02)
			printf ("You have already tried using %s\n", input);
		else if (!(isWord(computer, input) & 0x02))
			printf ("Your word '%s', does not exist on the board\n", input);
		else
			insertWord(user, input);

	}
	return user;
}

int main () {
	char* cube;
	Dict dict, comp, user;

	dict = createDict () ;
	insertFile ( dict, "dictionary.dat" );
	sortDict (dict);
	
	while (1) {
		cube = createCube("cubes.dat");
		printCube();
	
		comp=solveCube (cube, dict);
		sortDict(comp);
	
		user=userTurn (cube, dict, comp);
		printf("You found %d words\n", SizeOfDict(user) );
		printf("My turn, I found %d words\n", SizeOfDict(comp) );
		printDict(comp);
	}

}

