
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "cube.h"
#include "dict.h"
#include "boggle.h"

#ifndef timeval
typedef struct timeval {
    long        tv_sec;     /* seconds (XXX should be time_t) */
    long		tv_usec;    /* and microseconds */
} poop ;
#elif 
#define poop timeval
#endif

int time_diff (poop *time1, poop *time2){
	int diff;
	int i;
	diff=time2->tv_usec;
	for (i=0; i < time2->tv_sec - time1->tv_sec; i++) 
		diff+=1000000;
	diff-=time1->tv_usec;
	return diff;

}



int main () {
	char* cube;
	Dict dict, comp;
	poop start, insertion, sort, solve_start, solve_end;
	int i, time_constant;

	dict = createDict () ;
	cube = malloc (20);

	for (i=0; i < 16; i++) {
		while (!isalpha(cube[i] = getchar()));
	}

	gettimeofday ( &start );
	gettimeofday ( &sort );
	time_constant = time_diff(&start, &sort);

	gettimeofday ( &start );
	insertFile ( dict, "/usr/share/dict/words" );
	gettimeofday ( &insertion );
	sortDict (dict);
	gettimeofday ( &sort );


	for (i=3; i>=0 ; i--)
	    printf("\t%c %c %c %c\n", cube[i*4],     cube[1+(i*4)],
	                              cube[(i*4)+2], cube[(i*4)+3] );

	gettimeofday ( &solve_start );
	comp=solveCube (cube, dict);
	gettimeofday ( &solve_end );
	sortDict(comp);
	printf("Found %d words\n", SizeOfDict(comp) );
	printDict(comp);

	printf("insertFile took %10d mS\n", (time_diff(&start, &insertion) - time_constant)/1000);
	printf("sortDict took   %10d mS\n", (time_diff(&insertion, &sort)    - time_constant)/1000);
	printf("solveCube took  %10d mS\n", (time_diff(&solve_start, &solve_end)   - time_constant)/1000);

}

